<template>
  <div>
    <v-col justify="space-between">
      <v-col cols="12" md="auto">
        <bulk-data
          :username="username"
        />
      </v-col>

      <v-col cols="12" md="auto" class="upload-component">
        <uploading-file
          @csv-uploaded="handleCsvFile"
        />
      </v-col>

      <v-col cols="12" md="auto" class="upload-button">
        <start-bulk-button
          @confirm="confirmRegistration"
        />
      </v-col>
    </v-col>
    <v-snackbar v-model="snackBar.show" :color="snackBar.color" text top>
      {{ snackBar.text }}
      <template #action="{ attrs }">
        <v-btn color="error" text v-bind="attrs" @click="exit">
          <v-icon>mdi-window-close</v-icon>
        </v-btn>
      </template>
    </v-snackbar>
    <confirmation-modal
      :loading="loading"
      :is-open="showModal"
      :modal-text="modalText"
      @confirm="registerBulkLoad"
      @cancel="cancelRegistration"
    />
  </div>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import BulkData from '~/components/BulkLoad/RegisterBulkLoad/BulkData';
import UploadingFile from '~/components/BulkLoad/RegisterBulkLoad/UploadingFile';
import ConfirmationModal from '~/components/register/confirmationModal';
import StartBulkButton from '~/components/BulkLoad/RegisterBulkLoad/StartBulkButton';

export default {
  name: 'RegisterBulkLoad',
  components: {
    BulkData,
    UploadingFile,
    ConfirmationModal,
    StartBulkButton,
  },
  data() {
    return {
      snackBar: {
        show: false,
        color: 'primary',
        text: '',
      },
      file: null,
      filename: null,
      showModal: false,
      modalText: '¿Está seguro que desea realizar la carga masiva?',
    };
  },
  computed: {
    ...mapState({
      providerCompany: state => state.providercompany.providercompany.providerCompany,
      loading: state => state.bulk.loading,
      error: state => state.bulk.error,
      username: state => state.auth.userAuth.username,
    }),
  },
  methods: {
    ...mapActions({
      saveBulkLoad: 'bulk/saveBulkLoad',
    }),
    handleCsvFile({ file, filename }) {
      this.file = file;
      this.filename = filename;
    },
    confirmRegistration() {
      if (this.file === null) {
        this.snackBar.text = 'Debe ingresar un archivo a registrar';
        this.snackBar.color = 'red';
        this.snackBar.show = true;
      } else {
        this.showModal = true;
      }
    },
    async registerBulkLoad() {
      await this.saveBulkLoad(this.file);
      if (this.error !== null) {
        this.snackBar.text = 'Ha ocurrido un error en la carga masiva';
        this.snackBar.color = 'red';
      } else {
        this.snackBar.text = 'Carga Masiva registrada';
        await this.$router.push('/cargas-masivas');
      }
      this.snackBar.show = true;
    },
    cancelRegistration() {
      this.showModal = false;
    },
    exit() {
      this.snackBar.show = false;
      if (this.error !== null) {
        this.$router.push('/cargas-masivas');
      }
    },
  },
};
</script>

<style scoped>
.v-card__title {
  font-size: 1.5rem !important;
}
.upload-component {
  text-align-last: center;
}
.upload-button {
  text-align-last: center;
}
span.v-btn__content {
  margin-left: -1em;
}
</style>
